/*
Copyright Renaud GICQUEL 2005-2006  
renaud.gicquel@ensmp.fr

Ce logiciel est un programme informatique servant  modliser des systmes nergtiques.   

Ce logiciel est rgi par la licence CeCILL soumise au droit franais et respectant les principes de diffusion des logiciels libres. Vous pouvez utiliser, modifier et/ou redistribuer ce programme sous les conditions de la licence CeCILL telle que diffuse par le CEA, le CNRS et l'INRIA  sur le site "http://www.cecill.info".  

En contrepartie de l'accessibilit au code source et des droits de copie, de modification et de redistribution accords par cette licence, il n'est offert aux utilisateurs qu'une garantie limite.  Pour les mmes raisons, seule une responsabilit restreinte pse sur l'auteur du programme,  le titulaire des droits patrimoniaux et les concdants successifs.  

A cet gard  l'attention de l'utilisateur est attire sur les risques associs au chargement,   l'utilisation,   la modification et/ou au dveloppement et  la reproduction du logiciel par l'utilisateur tant  donn sa spcificit de logiciel libre, qui peut le rendre complexe   manipuler et qui le rserve donc  des dveloppeurs et des professionnels avertis possdant  des  connaissances  informatiques approfondies.  Les utilisateurs sont donc invits  charger  et  tester  l'adquation  du logiciel  leurs besoins dans des conditions permettant d'assurer la scurit de leurs systmes et ou de leurs donnes et, plus gnralement,   l'utiliser et l'exploiter dans les mmes conditions de scurit.   

Le fait que vous puissiez accder  cet en-tte signifie que vous avez  pris connaissance de la licence CeCILL, et que vous en avez accept les termes. 

This software is a computer program whose purpose is to model energy systems.  

This software is governed by the CeCILL  license under French law and abiding by the rules of distribution of free software.  You can  use,  modify and/ or redistribute the software under the terms of the CeCILL license as circulated by CEA, CNRS and INRIA at the following URL "http://www.cecill.info".   

As a counterpart to the access to the source code and  rights to copy, modify and redistribute granted by the license, users are provided only with a limited warranty  and the software's author,  the holder of the economic rights,  and the successive licensors  have only  limited liability.   

In this respect, the user's attention is drawn to the risks associated with loading,  using,  modifying and/or developing or reproducing the software by the user in light of its specific status of free software, that may mean  that it is complicated to manipulate,  and  that  also therefore means  that it is reserved for developers  and  experienced professionals having in-depth computer knowledge. Users are therefore encouraged to load and test the software's suitability as regards their requirements in conditions enabling the security of their systems and/or  data to be ensured and,  more generally, to use and operate it in the  same conditions as regards security.   

The fact that you are presently reading this means that you have had knowledge of the CeCILL license and that you accept its terms.  
*/
package extThopt;

import java.awt.*;
import java.io.BufferedReader;
import java.io.PrintWriter;
import java.util.*;

import rg.corps.Corps;

/**
 * Classe pour calculer le bilan nergtique d'un moteur Stirling
 *
 * @author Renaud GICQUEL
 */
public class PilotePAC_f_Text extends ExtPilot implements Emulable
{
	/**
	 * 
	 */
	boolean isInitialized=false;
	boolean isBuilt=false;
	String[]composant,nomComposant;
    String condenserName="",expansionName="";
    String compressorName="",expansionValveName="",desuperheaterName="";
    String evaporatorName="";
    double Tchauff, Tair, N_rot, coldPinch, hotPinch, Pcompr,m_compr, eta_c;
    PointThopt T1Point, T2Point, T3aPoint, T3Point, T4Point, TairPoint, TheatPoint;
    Corps refrig;
    double K_flow=0.03;
    double c3=0.007390, c2=-0.126576, c1=29.247459;

    double aColdPinch=9,   bColdPinch=0.2;
    double aHotPinch=12,   bHotPinch=0.2;
    double aTchauff=52,   bTchauff=-0.6;
    double K1=0.65,K2=3.5,K3=-14;
    double a0_v = 0.85;
    double alpha_v = -0.01;

    double A, B, C;
    double RCE=0.,RCD=3.122155,RCC=-0.001555,RCB=0.146048,RCA=1.190024;
    		
    double TIT_max=1350,TIT_min=400;


	public PilotePAC_f_Text()
	{
		//{{INIT_CONTROLS
		setTitle("Simulateur de pompe  chaleur");
		getContentPane().setLayout(null);
		setSize(382,628);
		setVisible(false);
		JLabel1.setText("temprature air (C)");
		getContentPane().add(JLabel1);
		JLabel1.setBounds(24,60,156,24);
		tair_value.setText("-20");
		getContentPane().add(tair_value);
		tair_value.setBounds(192,60,96,24);
		tair_value.setSelectionColor(new java.awt.Color(204,204,255));
		tair_value.setSelectedTextColor(java.awt.Color.black);
		tair_value.setCaretColor(java.awt.Color.black);
		tair_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		JLabel3.setText("P chauffage (kW)");
		getContentPane().add(JLabel3);
		JLabel3.setForeground(java.awt.Color.red);
		JLabel3.setBounds(24,303,156,24);
		getContentPane().add(Qheater_value);
		Qheater_value.setForeground(java.awt.Color.red);
		Qheater_value.setBounds(192,303,96,24);
		Qheater_value.setSelectionColor(new java.awt.Color(204,204,255));
		Qheater_value.setSelectedTextColor(java.awt.Color.black);
		Qheater_value.setCaretColor(java.awt.Color.black);
		Qheater_value.setDisabledTextColor(java.awt.Color.lightGray);
		Qheater_value.setEditable(false);
		JLabel14.setText("Pcond (bar)");
		getContentPane().add(JLabel14);
		JLabel14.setBounds(24,444,156,24);
		P3_value.setText("17");
		getContentPane().add(P3_value);
		P3_value.setBounds(192,444,96,24);
		P3_value.setSelectionColor(new java.awt.Color(204,204,255));
		P3_value.setSelectedTextColor(java.awt.Color.black);
		P3_value.setCaretColor(java.awt.Color.black);
		P3_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		P3_value.setEditable(false);
		JLabel2.setText("eta_c");
		getContentPane().add(JLabel2);
		JLabel2.setBounds(24,516,156,24);
		eta_c_value.setText("0.8");
		getContentPane().add(eta_c_value);
		eta_c_value.setBounds(192,516,96,24);
		eta_c_value.setSelectionColor(new java.awt.Color(204,204,255));
		eta_c_value.setSelectedTextColor(java.awt.Color.black);
		eta_c_value.setCaretColor(java.awt.Color.black);
		eta_c_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		eta_c_value.setEditable(false);
		JLabel4.setText("COP");
		getContentPane().add(JLabel4);
		JLabel4.setForeground(java.awt.Color.red);
		JLabel4.setBounds(24,336,156,24);
		eta_value.setSelectionColor(new java.awt.Color(204,204,255));
		eta_value.setSelectedTextColor(java.awt.Color.black);
		eta_value.setCaretColor(java.awt.Color.black);
		eta_value.setDisabledTextColor(java.awt.Color.lightGray);
		eta_value.setEditable(false);
		getContentPane().add(eta_value);
		eta_value.setForeground(java.awt.Color.red);
		eta_value.setBounds(192,336,96,24);
		JLabel9.setText("P compr. (kW)");
		JLabel9.setForeground(java.awt.Color.red);
		getContentPane().add(JLabel9);
		JLabel9.setBounds(24,270,156,24);
		puissance_value.setForeground(java.awt.Color.red);
		puissance_value.setSelectionColor(new java.awt.Color(204,204,255));
		puissance_value.setSelectedTextColor(java.awt.Color.black);
		puissance_value.setCaretColor(java.awt.Color.black);
		puissance_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		puissance_value.setEditable(false);
		getContentPane().add(puissance_value);
		puissance_value.setBounds(192,270,96,24);
		JLabel6.setText("P vaporation (bar)");
		getContentPane().add(JLabel6);
//		JLabel6.setForeground(java.awt.Color.red);
		JLabel6.setBounds(24,408,156,24);
		getContentPane().add(Pevap_value);
//		Pevap_value.setForeground(java.awt.Color.red);
		Pevap_value.setBounds(192,408,96,24);
		Pevap_value.setSelectionColor(new java.awt.Color(204,204,255));
		Pevap_value.setSelectedTextColor(java.awt.Color.black);
		Pevap_value.setCaretColor(java.awt.Color.black);
		Pevap_value.setDisabledTextColor(java.awt.Color.lightGray);
		Pevap_value.setEditable(false);
		bCalculate.setText("Calculer");
		bCalculate.setActionCommand("Calculate ");
		getContentPane().add(bCalculate);
		bCalculate.setBounds(100,170,250,48);
		JLabel13.setText("adresse IP");
		getContentPane().add(JLabel13);
//		JLabel13.setForeground(java.awt.Color.red);
		JLabel13.setBounds(130,230,70,24);
		IP_value.setSelectionColor(new java.awt.Color(204,204,255));
		IP_value.setSelectedTextColor(java.awt.Color.black);
		IP_value.setCaretColor(java.awt.Color.black);
		IP_value.setDisabledTextColor(java.awt.Color.lightGray);
		IP_value.setBounds(200,225,80,24);
		getContentPane().add(IP_value);
		JLabel10.setText("Simulateur de pompe  chaleur");
		getContentPane().add(JLabel10);
		JLabel10.setForeground(java.awt.Color.blue);
		JLabel10.setFont(new Font("Dialog", Font.BOLD, 18));
		JLabel10.setBounds(12,0,348,24);
/*		N_value.setText("3600");
		N_value.setSelectionColor(new java.awt.Color(204,204,255));
		N_value.setSelectedTextColor(java.awt.Color.black);
		N_value.setCaretColor(java.awt.Color.black);
		N_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		getContentPane().add(N_value);
		N_value.setBounds(192,96,96,24);
		JLabel8.setText("vitesse de rotation");
		getContentPane().add(JLabel8);
		JLabel8.setBounds(24,96,156,24);
		tempSlider.setValue(90);
		tempSlider.setToolTipText("Rglage de la puissance");
		tempSlider.setOrientation(javax.swing.JSlider.VERTICAL);
		getContentPane().add(tempSlider);
		tempSlider.setBounds(60,132,24,132);*/
		JLabel11.setText("T chauffage (C)");
		getContentPane().add(JLabel11);
		JLabel11.setForeground(java.awt.Color.red);
		JLabel11.setBounds(24,372,156,24);
		Tchauff_value.setSelectionColor(new java.awt.Color(204,204,255));
		Tchauff_value.setSelectedTextColor(java.awt.Color.black);
		Tchauff_value.setCaretColor(java.awt.Color.black);
		Tchauff_value.setDisabledTextColor(java.awt.Color.lightGray);
		Tchauff_value.setEditable(false);
		getContentPane().add(Tchauff_value);
		Tchauff_value.setForeground(java.awt.Color.red);
		Tchauff_value.setBounds(192,372,96,24);
		JLabel5.setText("T2 (C)");
		getContentPane().add(JLabel5);
		JLabel5.setBounds(24,480,156,24);
		t2_value.setText("1,5");
		t2_value.setSelectionColor(new java.awt.Color(204,204,255));
		t2_value.setSelectedTextColor(java.awt.Color.black);
		t2_value.setCaretColor(java.awt.Color.black);
		t2_value.setDisabledTextColor(new java.awt.Color(153,153,153));
		t2_value.setEditable(false);
		getContentPane().add(t2_value);
		t2_value.setBounds(192,480,96,24);
/*		JLabel7.setText("Pmax");
		getContentPane().add(JLabel7);
		JLabel7.setBounds(24,132,48,24);
		JLabel12.setText("Pmin");
		getContentPane().add(JLabel12);
		JLabel12.setBounds(24,232,48,24);*/
		//}}

		//{{REGISTER_LISTENERS
		SymWindow aSymWindow = new SymWindow();
		this.addWindowListener(aSymWindow);
		SymAction lSymAction = new SymAction();
		bCalculate.addActionListener(lSymAction);
		
		SymMouse aSymMouse = new SymMouse();
		tempSlider.addMouseListener(aSymMouse);
		//}}
    
		//{{INIT_MENUS
		//}}

//		getContentPane().remove(bCalculate);
		getContentPane().remove(IP_value);
		getContentPane().remove(JLabel13);
		type="PAC f(Text)";
		
	}

	public String getClassDescription(){
	    return "pilote de pompe  chaleur avec serveur\n\nauthor : R. Gicquel juillet 2012";
	}

	public void setVisible(boolean b)
	{
		if(b)
		{
			setLocation(50, 50);
		}
	super.setVisible(b);
	}

	public void addNotify()
	{
		// Record the size of the window prior to calling parents addNotify.
		Dimension d = getSize();

		super.addNotify();

		if (fComponentsAdjusted)
			return;

		// Adjust components according to the insets
		Insets ins = getInsets();
		setSize(ins.left + ins.right + d.width, ins.top + ins.bottom + d.height);
		Component components[] = getContentPane().getComponents();
		for (int i = 0; i < components.length; i++)
			{
			Point p = components[i].getLocation();
			p.translate(ins.left, ins.top);
			components[i].setLocation(p);
		}
		fComponentsAdjusted = true;
	}

	// Used for addNotify check.
	boolean fComponentsAdjusted = false;

	class SymWindow extends java.awt.event.WindowAdapter
	{
		public void windowClosing(java.awt.event.WindowEvent event)
		{
		Object object = event.getSource();
		if (object == PilotePAC_f_Text.this)
			PiloteFrigoServer_WindowClosing(event);
		}
	}

	void PiloteFrigoServer_WindowClosing(java.awt.event.WindowEvent event)
	{
		dispose();		 // dispose of the Frame.
	}
	//{{DECLARE_CONTROLS
	javax.swing.JLabel JLabel1 = new javax.swing.JLabel();
	public javax.swing.JTextField tair_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel2 = new javax.swing.JLabel();
	javax.swing.JTextField eta_c_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel3 = new javax.swing.JLabel();
	javax.swing.JTextField Qheater_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel6 = new javax.swing.JLabel();
	javax.swing.JTextField Pevap_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel4 = new javax.swing.JLabel();
	javax.swing.JTextField eta_value = new javax.swing.JTextField();
	javax.swing.JButton bCalculate = new javax.swing.JButton();
	javax.swing.JLabel JLabel10 = new javax.swing.JLabel();
	javax.swing.JTextField puissance_value = new javax.swing.JTextField();
	javax.swing.JTextField N_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel8 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel9 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel11 = new javax.swing.JLabel();
	javax.swing.JTextField Tchauff_value = new javax.swing.JTextField();
	javax.swing.JSlider tempSlider = new javax.swing.JSlider();
	javax.swing.JLabel JLabel5 = new javax.swing.JLabel();
	javax.swing.JTextField t2_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel7 = new javax.swing.JLabel();
	javax.swing.JLabel JLabel12 = new javax.swing.JLabel();
	javax.swing.JTextField IP_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel13 = new javax.swing.JLabel();
	javax.swing.JTextField P3_value = new javax.swing.JTextField();
	javax.swing.JLabel JLabel14 = new javax.swing.JLabel();
	//}}

	//{{DECLARE_MENUS
	//}}


	class SymAction implements java.awt.event.ActionListener
	{
		public void actionPerformed(java.awt.event.ActionEvent event)
		{
			Object object = event.getSource();
			if (object == bCalculate)
				bCalculate_actionPerformed(event);
		}
	}	

		public void init(){
		isInitialized=true;
		proj=getProjet();
		//On rcupre la liste et le type des composants prsents dans l'diteur de schmas
		//Retrieves the list and the type of components in the diagram editor
		String[]listComp=proj.getEditorComponentList();
		composant=new String[listComp.length];
		nomComposant=new String[listComp.length];
		
        
        compressorName="compresseur";
        condenserName="condenseur";
        expansionValveName="dtendeur";
        desuperheaterName="dsurchauffeur";
        evaporatorName="vaporateur";
        T1Point=new PointThopt(proj,"1");
        T2Point=new PointThopt(proj,"2");
        T3aPoint=new PointThopt(proj,"3a");
        T3Point=new PointThopt(proj,"3");
        T4Point=new PointThopt(proj,"4");
        TairPoint=new PointThopt(proj,"air extrieur");
//        TairPoint.getProperties();
        TheatPoint=new PointThopt(proj,"retour chauffage");
        refrig=T4Point.lecorps;
//        tair_value.setText(Util.aff_d(TairPoint.T-273.15, 3));
/*        
        tempSlider.setMinimum((int) TIT_min);
        tempSlider.setMaximum((int) TIT_max);
 
        tempSlider.setValue((int) (T4Point.T-273.15));
        */
		if(isBuilt)setVisible(true);//on n'ouvre le pilote que si sa structure est correcte
		                    //the driver cannot be open if its structure is wrong
	}

	void bCalculate_actionPerformed(java.awt.event.ActionEvent event){
	    calculate();
	}
	public void calculate(){
	    if(!isInitialized)init();//la premire fois, on initialise, car il faut un constructeur sans argument
	                            //pour instancier la classe par le RMI
	                            //the initialization is made during the first call, as the constructor 
	                            //must have no argument because the class is instanciated by the RMI
	    
//        N_rot=Util.lit_d(N_value.getText());
        double T_air= Util.lit_d(tair_value.getText())+273.15;
	    double oldTair=TairPoint.T;
	    double deltaTair=T_air-oldTair;
	    for(int i=0;i<20;i++){
	    	Tair=oldTair+deltaTair/19*i;//rampe
        	System.out.println("Tair "+Tair);
		    Tchauff= aTchauff+bTchauff*(Tair-273.15)+273.15;
		    
	        TairPoint.T=Tair;
	        TairPoint.update(UPDATE_T,UPDATE_P,!UPDATE_X);
	        TheatPoint.T=Tchauff;
	        TheatPoint.update(UPDATE_T,UPDATE_P,!UPDATE_X);
	
		    coldPinch=aColdPinch+bColdPinch*(Tair-273.15);
		    hotPinch=aHotPinch+bHotPinch*(Tair-273.15);
		    T4Point.T=Tair-coldPinch;
		    T3aPoint.T=Tchauff+hotPinch;
		    double Pevap=refrig.getSatPressure(T4Point.T, 1);
		    T4Point.P=Pevap;
		    T4Point.update(UPDATE_T,UPDATE_P,!UPDATE_X);
		    T4Point.getProperties();
		    T1Point.P=Pevap;
		    T1Point.T=T4Point.T+3;
		    T1Point.update(UPDATE_T,UPDATE_P,!UPDATE_X);
		    double Pcond=refrig.getSatPressure(T3aPoint.T, 1);
		    T3aPoint.P=Pcond;
		    T3aPoint.update(UPDATE_T,UPDATE_P,!UPDATE_X);
		    T3aPoint.getProperties();
		    T3Point.P=Pcond;
		    T3Point.T=T3aPoint.T-2;
		    T3Point.update(UPDATE_T,UPDATE_P,!UPDATE_X);
		    T3Point.getProperties();
		    T2Point.P=Pcond;
		    T2Point.update(!UPDATE_T,UPDATE_P,!UPDATE_X);
	        String[] args=new String[2];
	        args=new String[2];
	        args[0]="process";
	        args[1]=compressorName;
	        Vector vProp=proj.getProperties(args);
	        Double f=(Double)vProp.elementAt(4);
	        double tauCompr=f.doubleValue();
	        f=(Double)vProp.elementAt(3);
	        double m_refrig=f.doubleValue();
	        m_compr=Pcompr/tauCompr*m_refrig;
		    T1Point.getProperties();
	        double RC=T2Point.P/T1Point.P;

		    double lambda_v = a0_v + alpha_v*RC;
		    m_compr=K_flow*lambda_v/T1Point.V;
		    
		    //quation  3 paramtres pour eta_c
	        eta_c= K3/RC/RC + K2/RC + K1;
	        if(eta_c>0.9)eta_c=0.9;
	        if(eta_c<0.5)eta_c=0.5;
	
			updateprocess(evaporatorName, "Exchange",RECALCULATE,IS_SET_FLOW, UPDATE_FLOW, m_compr,  !UPDATE_ETA, 1);
	        updateprocess(compressorName, "Compression",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, 1,  UPDATE_ETA, eta_c);
		    
	        updateprocess(desuperheaterName, "Exchange",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, 0, !UPDATE_ETA, 1);
	        updateprocess(condenserName, "Exchange",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, 0, !UPDATE_ETA, 1);
	        updateprocess(expansionValveName, "Throttle",RECALCULATE,!IS_SET_FLOW, !UPDATE_FLOW, 1,  !UPDATE_ETA, 1);
		    
		    for(int j=0;j<5;j++)proj.calcThopt();
		    
	        args=new String[2];
	        args=new String[2];
	        args[0]="process";
	        args[1]=compressorName;
	        vProp=proj.getProperties(args);
	        f=(Double)vProp.elementAt(4);
	        tauCompr=f.doubleValue();

	        args[1]=condenserName;
	        vProp=proj.getProperties(args);
	        f=(Double)vProp.elementAt(4);
	        double Qcond=-f.doubleValue();
	
	        args[1]=desuperheaterName;
	        vProp=proj.getProperties(args);
	        f=(Double)vProp.elementAt(4);
	        double Qdes=-f.doubleValue();
	        
	        double Qheater=Qcond+Qdes;
	        puissance_value.setText(Util.aff_d(tauCompr,3));
		    eta_value.setText(Util.aff_d(Qheater/tauCompr,3));
		    Qheater_value.setText(Util.aff_d(Qheater,3));
		    Pevap_value.setText(Util.aff_d(Pevap,3));
		    Tchauff_value.setText(Util.aff_d(Tchauff-273.15,3));
		    P3_value.setText(Util.aff_d(T3Point.P,3));
		    
		    T2Point.getProperties();
			eta_c_value.setText(Util.aff_d(eta_c,5));
			t2_value.setText(Util.aff_d(T2Point.T-273.15,3));
	    }
	}

	class SymMouse extends java.awt.event.MouseAdapter
	{
		public void mouseReleased(java.awt.event.MouseEvent event)
		{
			Object object = event.getSource();
			if (object == tempSlider)
				tempSlider_mouseReleased(event);
		}
	}

	void tempSlider_mouseReleased(java.awt.event.MouseEvent event)
	{
	    if(!isInitialized)init();
	    Tchauff=(double)tempSlider.getValue()+273.15;
		calculate();
				 
	}
	public void setParameters(String[] params){
		tair_value.setText(params[0]);
		K_flow=Util.lit_d(params[1]);
	
	}
	public String[] getValues(){
/*		String[]res= new String[9];
		res[0]="Text = "+tair_value.getText();
		res[1]="Pcompr = "+puissance_value.getText();
		res[2]="dbit = "+Util.aff_d(m_compr,5);
		res[3]="T2 = "+eta_c_value.getText();
		res[4]="P2 = "+t2_value.getText();
		res[5]="P chauffe = "+Qheater_value.getText();
		res[6]="Pevap = "+Pevap_value.getText();
		res[7]="T chauffe = "+Tchauff_value.getText();
		res[8]="COP = "+eta_value.getText();*/
		String[]res= new String[2];
		res[0]="Text"+"\t"+"Pcompr"+"\t"+"dbit"+"\t"+"Pcond"+"\t"+"eta_c"
		+"\t"+"P chauffe"+"\t"+"Pevap"+"\t"+"T chauffe"+"\t"+"COP";
		res[1]=tair_value.getText()+"\t"+puissance_value.getText()+"\t"+Util.aff_d(m_compr,5)
		+"\t"+P3_value.getText()+"\t"+eta_c_value.getText()+"\t"+Qheater_value.getText()
		+"\t"+Pevap_value.getText()+"\t"+Tchauff_value.getText()+"\t"+eta_value.getText();
		return res;
	}

}